#!/usr/bin/env bash
set -e

# Clean-up /tmp directory from files which might have remained from previous container restart
# We ignore any errors which might be caused by files injected by different agents which we do not have the rights to delete
rm -rfv /tmp/* || true

export JAVA_CLASSPATH=$JAVA_CLASSPATH:lib/io.strimzi.cluster-operator-0.45.0.jar:lib/io.strimzi.api-0.45.0.jar:lib/io.fabric8.kubernetes-model-apiextensions-6.13.4.jar:lib/io.strimzi.config-model-0.45.0.jar:lib/io.strimzi.operator-common-0.45.0.jar:lib/io.strimzi.crd-annotations-0.45.0.jar:lib/org.quartz-scheduler.quartz-2.3.2.jar:lib/org.eclipse.jetty.jetty-server-9.4.56.v20240826.jar:lib/org.eclipse.jetty.jetty-http-9.4.56.v20240826.jar:lib/org.eclipse.jetty.jetty-io-9.4.56.v20240826.jar:lib/javax.servlet.javax.servlet-api-3.1.0.jar:lib/io.fabric8.openshift-client-6.13.4.jar:lib/com.github.mifmif.generex-1.0.2.jar:lib/dk.brics.automaton.automaton-1.11-8.jar:lib/io.fabric8.openshift-client-api-6.13.4.jar:lib/io.fabric8.openshift-model-clusterautoscaling-6.13.4.jar:lib/io.fabric8.openshift-model-operator-6.13.4.jar:lib/io.fabric8.openshift-model-operatorhub-6.13.4.jar:lib/io.fabric8.openshift-model-machine-6.13.4.jar:lib/io.fabric8.openshift-model-whereabouts-6.13.4.jar:lib/io.fabric8.openshift-model-monitoring-6.13.4.jar:lib/io.fabric8.openshift-model-storageversionmigrator-6.13.4.jar:lib/io.fabric8.openshift-model-tuned-6.13.4.jar:lib/io.fabric8.openshift-model-console-6.13.4.jar:lib/io.fabric8.openshift-model-config-6.13.4.jar:lib/io.fabric8.openshift-model-machineconfig-6.13.4.jar:lib/io.fabric8.openshift-model-miscellaneous-6.13.4.jar:lib/io.fabric8.openshift-model-hive-6.13.4.jar:lib/io.fabric8.openshift-model-installer-6.13.4.jar:lib/io.fabric8.kubernetes-client-6.13.4.jar:lib/io.fabric8.kubernetes-httpclient-jdk-6.13.4.jar:lib/io.fabric8.kubernetes-client-api-6.13.4.jar:lib/io.fabric8.kubernetes-model-gatewayapi-6.13.4.jar:lib/io.fabric8.kubernetes-model-resource-6.13.4.jar:lib/io.fabric8.kubernetes-model-admissionregistration-6.13.4.jar:lib/io.fabric8.kubernetes-model-autoscaling-6.13.4.jar:lib/io.fabric8.kubernetes-model-batch-6.13.4.jar:lib/io.fabric8.kubernetes-model-certificates-6.13.4.jar:lib/io.fabric8.kubernetes-model-discovery-6.13.4.jar:lib/io.fabric8.kubernetes-model-extensions-6.13.4.jar:lib/io.fabric8.kubernetes-model-flowcontrol-6.13.4.jar:lib/io.fabric8.kubernetes-model-metrics-6.13.4.jar:lib/io.fabric8.kubernetes-model-scheduling-6.13.4.jar:lib/io.fabric8.kubernetes-model-node-6.13.4.jar:lib/org.slf4j.slf4j-api-1.7.36.jar:lib/org.snakeyaml.snakeyaml-engine-2.7.jar:lib/com.fasterxml.jackson.datatype.jackson-datatype-jsr310-2.16.2.jar:lib/io.fabric8.kubernetes-model-core-6.13.4.jar:lib/io.fabric8.kubernetes-model-common-6.13.4.jar:lib/io.fabric8.kubernetes-model-events-6.13.4.jar:lib/io.fabric8.kubernetes-model-policy-6.13.4.jar:lib/io.fabric8.kubernetes-model-rbac-6.13.4.jar:lib/io.fabric8.kubernetes-model-apps-6.13.4.jar:lib/io.fabric8.kubernetes-model-storageclass-6.13.4.jar:lib/io.fabric8.kubernetes-model-networking-6.13.4.jar:lib/io.fabric8.kubernetes-model-coordination-6.13.4.jar:lib/io.fabric8.openshift-model-6.13.4.jar:lib/io.fabric8.zjsonpatch-0.3.0.jar:lib/com.fasterxml.jackson.core.jackson-core-2.16.2.jar:lib/com.fasterxml.jackson.core.jackson-databind-2.16.2.jar:lib/com.fasterxml.jackson.core.jackson-annotations-2.16.2.jar:lib/com.fasterxml.jackson.dataformat.jackson-dataformat-yaml-2.16.2.jar:lib/org.yaml.snakeyaml-2.2.jar:lib/io.vertx.vertx-core-4.5.11.jar:lib/io.netty.netty-common-4.1.115.Final.jar:lib/io.netty.netty-buffer-4.1.115.Final.jar:lib/io.netty.netty-handler-4.1.115.Final.jar:lib/io.netty.netty-handler-proxy-4.1.115.Final.jar:lib/io.netty.netty-codec-http-4.1.115.Final.jar:lib/io.netty.netty-codec-http2-4.1.115.Final.jar:lib/io.netty.netty-resolver-4.1.115.Final.jar:lib/io.netty.netty-resolver-dns-4.1.115.Final.jar:lib/io.netty.netty-codec-dns-4.1.115.Final.jar:lib/io.strimzi.certificate-manager-0.45.0.jar:lib/org.apache.logging.log4j.log4j-core-2.17.2.jar:lib/org.apache.logging.log4j.log4j-api-2.17.2.jar:lib/org.apache.logging.log4j.log4j-slf4j-impl-2.17.2.jar:lib/io.strimzi.kafka-oauth-server-0.15.0.jar:lib/io.strimzi.kafka-oauth-server-plain-0.15.0.jar:lib/io.strimzi.kafka-oauth-client-0.15.0.jar:lib/io.strimzi.kafka-oauth-common-0.15.0.jar:lib/com.nimbusds.nimbus-jose-jwt-9.37.2.jar:lib/com.github.stephenc.jcip.jcip-annotations-1.0-1.jar:lib/com.jayway.jsonpath.json-path-2.9.0.jar:lib/net.minidev.json-smart-2.5.0.jar:lib/net.minidev.accessors-smart-2.5.0.jar:lib/org.eclipse.jetty.jetty-util-9.4.56.v20240826.jar:lib/org.apache.kafka.kafka-clients-3.9.0.jar:lib/com.github.luben.zstd-jni-1.5.6-4.jar:lib/org.lz4.lz4-java-1.8.0.jar:lib/org.apache.kafka.kafka-server-common-3.9.0.jar:lib/com.yammer.metrics.metrics-core-2.2.0.jar:lib/net.sf.jopt-simple.jopt-simple-5.0.4.jar:lib/org.pcollections.pcollections-4.0.1.jar:lib/org.apache.zookeeper.zookeeper-3.8.4.jar:lib/org.apache.yetus.audience-annotations-0.12.0.jar:lib/commons-io.commons-io-2.11.0.jar:lib/org.apache.zookeeper.zookeeper-jute-3.8.4.jar:lib/io.netty.netty-transport-4.1.115.Final.jar:lib/io.netty.netty-transport-native-epoll-4.1.115.Final-linux-x86_64.jar:lib/io.netty.netty-transport-native-unix-common-4.1.115.Final.jar:lib/io.netty.netty-transport-classes-epoll-4.1.115.Final.jar:lib/io.netty.netty-transport-native-epoll-4.1.115.Final-linux-aarch_64.jar:lib/io.micrometer.micrometer-core-1.12.3.jar:lib/io.micrometer.micrometer-commons-1.12.3.jar:lib/io.micrometer.micrometer-observation-1.12.3.jar:lib/org.hdrhistogram.HdrHistogram-2.1.12.jar:lib/org.latencyutils.LatencyUtils-2.0.3.jar:lib/io.micrometer.micrometer-registry-prometheus-1.12.3.jar:lib/io.prometheus.simpleclient_common-0.16.0.jar:lib/io.prometheus.simpleclient-0.16.0.jar:lib/io.prometheus.simpleclient_tracer_otel-0.16.0.jar:lib/io.prometheus.simpleclient_tracer_common-0.16.0.jar:lib/io.prometheus.simpleclient_tracer_otel_agent-0.16.0.jar:lib/io.vertx.vertx-micrometer-metrics-4.5.11.jar:lib/io.netty.netty-codec-4.1.115.Final.jar:lib/io.netty.netty-codec-socks-4.1.115.Final.jar
export JAVA_MAIN=io.strimzi.operator.cluster.Main

if [ -z "$KUBERNETES_SERVICE_DNS_DOMAIN" ]; then
  KUBERNETES_SERVICE_DNS_DOMAIN=$(getent hosts kubernetes.default | head -1 | sed "s/.*\skubernetes.default.svc//" | sed "s/\.//")
  if [ -n "$KUBERNETES_SERVICE_DNS_DOMAIN" ]; then
    echo "Auto-detected KUBERNETES_SERVICE_DNS_DOMAIN: $KUBERNETES_SERVICE_DNS_DOMAIN"
    export KUBERNETES_SERVICE_DNS_DOMAIN
  else
    echo "Auto-detection of KUBERNETES_SERVICE_DNS_DOMAIN failed. The default value cluster.local will be used."
  fi
else
  echo "KUBERNETES_SERVICE_DNS_DOMAIN is already set. Skipping auto-detection."
fi

if [ -f /opt/strimzi/custom-config/log4j2.properties ]; then
    # if ConfigMap was not mounted and thus this file was not created, use properties file from the classpath
    export JAVA_OPTS="${JAVA_OPTS} -Dlog4j2.configurationFile=file:/opt/strimzi/custom-config/log4j2.properties"
else
    echo "Configuration file log4j2.properties not found. Using default static logging setting. Dynamic updates of logging configuration will not work."
fi

# Used to identify cluster operator instance when publishing events
if [[ -z "$STRIMZI_OPERATOR_NAME" ]]; then
  STRIMZI_OPERATOR_NAME="$(cat /proc/sys/kernel/hostname)"
  export STRIMZI_OPERATOR_NAME
fi

export JAVA_OPTS="${JAVA_OPTS} -Dvertx.cacheDirBase=/tmp/vertx-cache"

exec "${STRIMZI_HOME}/bin/launch_java.sh"
